﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=12.2
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	Public Color As Int
End Sub

Sub Globals
	Private xui As XUI
	Private bar As StdActionBar
	Private dg As B4XDialog
	Private ListOfColorsPanel As B4XView
	Private clrsList As List
	Private clv1 As CustomListView
	Private lbl1 As Label
	Private lbl2 As Label
	Private lbl3 As Label
	Private lbl4 As Label
	Public dgresult As Int
	
	'https://mui.com/material-ui/customization/color/#picking-colors
	Private ColorsFilename As String = "colors.txt"
	Private pnlColors As Panel
End Sub

Sub Activity_Create(FirstTime As Boolean)
	bar.Initialize("bar")
	bar.NavigationMode = bar.NAVIGATION_MODE_STANDARD
	bar.ShowUpIndicator = True
	
	dg.Initialize(Activity)
	dg.Title = "Select a Color"
	dg.BorderWidth = 1dip
	dg.BorderColor = xui.Color_White
	dg.TitleBarColor = xui.Color_White
	dg.TitleBarTextColor = xui.Color_Black
	dg.BackgroundColor = xui.Color_White
	dg.ButtonsColor = xui.Color_White
	
	Activity.LoadLayout("SelectColor")
	
	clrsList.Initialize
	For Each line As String In File.ReadList(File.DirAssets, ColorsFilename)
		clrsList.Add(line)
	Next
	BuildDialog
End Sub

Sub Activity_Resume
End Sub

Sub Activity_Pause (UserClosed As Boolean)
End Sub

Sub Activity_ActionBarHomeClick
	Color = 0
	Activity.Finish
End Sub


Private Sub PickColor_Click
	Dim lbl As B4XView = Sender
	Main.Color = lbl.Color
	Activity.Finish
End Sub

Sub BuildDialog
	If ListOfColorsPanel.IsInitialized = False Then BuildListOfColors
	Dim rs As ResumableSub = dg.ShowCustom(ListOfColorsPanel,"","","CANCEL")
	Wait For (rs) Complete (Result As Int)
	dgresult = Result
	If Result = xui.DialogResponse_Cancel Then
		dg.Close(xui.DialogResponse_Cancel)
		Activity.Finish
	End If
End Sub

Sub BuildListOfColors
	ListOfColorsPanel = xui.CreatePanel("")
	ListOfColorsPanel.SetLayoutAnimated(0,0,0,75%x,80%y)
	ListOfColorsPanel.LoadLayout("SelectColor")
	ListOfColorsPanel.SetColorAndBorder(xui.Color_White,1dip,xui.Color_White,0dip)
	Fill_CLV
End Sub

Private Sub Fill_CLV
	clv1.Clear
	For i = 0 To (clrsList.Size/4) - 1
		Dim pnl As Panel = Create_Item(i)
		clv1.Add(pnl,i)
	Next
End Sub

Private Sub Create_Item(cnt As Int) As Panel
	Dim p As B4XView = xui.CreatePanel("")
	p.SetLayoutAnimated(0, 0dip, 0dip, 100%x,90dip)
	p.LoadLayout("clvitem_layout")
	pnlColors.Left = 15dip
	p.Left = 0dip
	
	p = Set_ItemColors(p,cnt)
	Return p
End Sub

Private Sub Set_ItemColors(pnl As Panel,cnt As Int) As Panel
	If (cnt*4) < clrsList.size Then
		For x = 0 To 3
			Dim hexstr As String = clrsList.Get((cnt*4)+x)
			Dim clrint As Int = Bit.Or(0xff000000, Bit.ParseInt(hexstr,16))
			'Dim clrint As Int = HexToColor(hexstr)
			'Log(clrint)
			Dim cdr As ColorDrawable
			cdr.Initialize(clrint,100)
			Select x
				Case 0
					lbl1.Background = cdr
					Dim b As B4XView = lbl1
					If b.Color = Color Then
						lbl1.Text = Chr(0xE876)
					End If
				Case 1
					lbl2.Background = cdr
					Dim b As B4XView = lbl2
					If b.Color = Color Then
						lbl2.Text = Chr(0xE876)
					End If
				Case 2
					lbl3.Background = cdr
					Dim b As B4XView = lbl3
					If b.Color = Color Then
						lbl3.Text = Chr(0xE876)
					End If
				Case 3
					lbl4.Background = cdr
					Dim b As B4XView = lbl4
					If b.Color = Color Then
						lbl4.Text = Chr(0xE876)
					End If
			End Select
		Next
	End If
	Return pnl
End Sub

'Private Sub HexToColor(Hex As String) As Int
'	Dim bc As ByteConverter
'	If Hex.StartsWith("#") Then
'		Hex = Hex.SubString(1)
'	Else If Hex.StartsWith("0x") Then
'		Hex = Hex.SubString(2)
'	End If
'	If Hex.Length = 6 Then
'		Hex = "FF" & Hex
'	End If
'	Dim ints() As Int = bc.IntsFromBytes(bc.HexToBytes(Hex))
'	Return ints(0)
'End Sub



